SystemOrganization addCategory: #'Moe-Tests'!

MODatalistObject subclass: #MOMockObject
	instanceVariableNames: 'field1 field2 field3 embedded scalar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:24'!
description1
	^MAStringDescription new
		accessor: #field1;
		label: 'field1';
		sqlColumnName: 'field1';
		sqlColumnType: 'text';
		priority: 10;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:37'!
description2
	^ MANumberDescription new
		accessor: #field2;
		label: 'field2';
		sqlColumnName: 'field2';
		sqlColumnType: 'integer';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:44'!
description3
	^MAStringDescription new
		accessor: #field3;
		label: 'field3';
		sqlColumnName: 'field3';
		sqlColumnType: 'text';
		priority: 12;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:44'!
descriptionEmbedded
	^ MOEmbeddedCollectionDescription new
		objectClass: MOMockTxObject;
		accessor: #embedded;
		label: 'embedded';
		sqlColumnName: 'embedded';
		sqlColumnType: 'integer[]';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:28'!
descriptionScalar
	^MAStringDescription new
		accessor: #scalar;
		label: 'scalar';
		priority: 14;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:45'!
tableName
	^'test'! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:55'!
testMappedDescription
	self assert: [ self mappedDescription size = 5 ].
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded
	"Answer the value of embedded"

	^ embedded! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded: anObject
	"Set the value of embedded"

	embedded := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

!MOMockObject methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:38'!
initialize
	field1 := '1'.
	field2 := 100.
	field3 := '3'.
	embedded := OrderedCollection new.
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar
	"Answer the value of scalar"

	^ scalar! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar: anObject
	"Set the value of scalar"

	scalar := anObject! !

MODatalistObject subclass: #MOMockSubObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockSubObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:46'!
description1
	^MAStringDescription new
		accessor: #field1;
		label: 'field1';
		sqlColumnName: 'field1';
		sqlColumnType: 'text';
		priority: 10;
		yourself! !

!MOMockSubObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:47'!
description2
	^ MOEmbeddedObjectDescription new
		objectClass: MOMockObject;
		accessor: #field2;
		label: 'field2';
		sqlColumnName: 'field2';
		sqlColumnType: 'integer';
		priority: 11;
		yourself! !

!MOMockSubObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:48'!
description3
	^MAStringDescription new
		accessor: #field3;
		label: 'field3';
		sqlColumnName: 'field3';
		sqlColumnType: 'text';
		priority: 12;
		yourself! !

!MOMockSubObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:24'!
tableName
	^'sub'! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

MODatalistObject subclass: #MOMockTxObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockTxObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:49'!
description1
	^MAStringDescription new
		accessor: #field1;
		label: 'field1';
		sqlColumnName: 'field1';
		sqlColumnType: 'text';
		priority: 10;
		yourself! !

!MOMockTxObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:49'!
description2
	^ MOEmbeddedObjectDescription new
		objectClass: MOMockSubObject;
		accessor: #field2;
		label: 'field2';
		sqlColumnName: 'field2';
		sqlColumnType: 'integer';
		priority: 11;
		yourself! !

!MOMockTxObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 19:49'!
description3
	^MAStringDescription new
		accessor: #field3;
		label: 'field3';
		sqlColumnName: 'field3';
		sqlColumnType: 'text';
		priority: 12;
		yourself! !

!MOMockTxObject class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:25'!
tableName
	^'tx'! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockTxObject methodsFor: 'accessing' stamp: 'jmck 2/26/2011 19:42'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

TestCase subclass: #MODatalistTest
	instanceVariableNames: 'object connectionArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MODatalistTest commentStamp: 'jmck 2/26/2011 21:16' prior: 0!
A MODatalistTest is a test class that tests circular referenced embedded objects do NOT cause an endless recursion. <applause>!

!MODatalistTest class methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 21:03'!
setUpDatabase
	MAConnectionPool shutDown.
	PGConnection defaultConnectionArgs: (PGConnectionArgs
		hostname: 'localhost'
		portno: 7117
		databaseName: 'test'
		userName: 'jmck'
		password: 'aqu1n@s').
	MAConnectionPool startUp.
	[ MOMockObject create.
	MOMockSubObject create.
	MOMockTxObject create ] on: Error do: [ :err | Transcript show: err; cr ].! !

!MODatalistTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 21:40'!
addEmbeddedObjects
	| tx sub |
	object := MOMockObject new save; yourself. 
	sub := MOMockSubObject new
		field1: '01';
		field2: object;
		field3: '03';
		save;
		yourself.
	tx := MOMockTxObject new
		field1: '001';
		field2: sub;
		field3: '003';
		save;
		yourself.
	object embedded add: tx.
	sub := MOMockSubObject new
		field1: '04';
		field2: object;
		field3: '05';
		save;
		yourself.
	tx := MOMockTxObject new
		field1: '004';
		field2: sub;
		field3: '005';
		save;
		yourself.
	object embedded add: tx.
	object save.
	MOMockObject reset.
	MOMockSubObject reset.
	MOMockTxObject reset.
	
	"object embedded add: (MOMockSubObject new 
				privateId: 2; 
				field1: 2; 
				field2: 3; 
				field3: 4; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 3; 
				field1: 3; 
				field2: 4; 
				field3: 5; 
				yourself)."
			! !

!MODatalistTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 21:06'!
setUp
	self addEmbeddedObjects.! !

!MODatalistTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:45'!
setUpDatabase
	MAConnectionPool shutDown.
	connectionArgs := PGConnection defaultConnectionArgs.
	PGConnection defaultConnectionArgs: (PGConnectionArgs
		hostname: 'localhost'
		portno: 7117
		databaseName: 'test'
		userName: 'jmck'
		password: 'aqu1n@s').
	MAConnectionPool startUp.
	[ MOMockObject create.
	MOMockSubObject create.
	MOMockTxObject create ] on: Error do: [ :err | Transcript show: err; cr ].! !

!MODatalistTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/20/2013 00:21'!
testAttributesMatchDescription
	
	self startUpClasses ifNotNil: [ :classlist |
	classlist
		inject: self relation discoverAttributes
		into: [ :lst :attr | | rslt |
			rslt := lst mappedDescription detect: [ :desc | desc sqlColumnName = attr name ] ifNone: [ nil ].
			self assert: rslt notNil ]]! !

!MODatalistTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 23:48'!
testRecursiveLoad
	"That all lists load successfully is proof that no errors were encountered
	Never mind. The test case DOES prove you cannot have circular referenced embedded object definitions"
	self assert: (MOMockObject list notNil and: [ MOMockObject list notEmpty ]).
	self assert: (MOMockSubObject list notNil and: [ MOMockSubObject list notEmpty ]).
	self assert: (MOMockTxObject list notNil and: [ MOMockTxObject list notEmpty ]).
	
	object := MOMockObject list first.
	self assert: object embedded notEmpty.
	self assert: [ (object embedded allSatisfy: [ :each |
		(each isKindOf: MOMockTxObject)
			and: [ (each field2 isKindOf: MOMockSubObject )
			and: [ each field2 field2 isKindOf: MOMockObject ]]
		]) ].
	
	
! !

TestCase subclass: #MOEmbeddedObjectTest
	instanceVariableNames: 'object connectionArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/14/2009 10:21'!
addEmbeddedObjects
	object embedded add: (MOMockSubObject new
				privateId: 1; 
				field1: 1; 
				field2: 2; 
				field3: 3; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 2; 
				field1: 2; 
				field2: 3; 
				field3: 4; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 3; 
				field1: 3; 
				field2: 4; 
				field3: 5; 
				yourself).
			! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/16/2009 13:09'!
setUp
	object := MOMockObject new. 
! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:48'!
testAttributeValueFor
	self assert: [ (object attributeValueFor: 'embedded') = '{}'].
	self addEmbeddedObjects.
	self assert: [ (object attributeValueFor: 'field1') = '1'].
	self assert: [ (object attributeValueFor: 'field2') = 100 ].
	self assert: [ (object attributeValueFor: 'field3') = '3'].
	self assert: [ (object attributeValueFor: 'embedded') = '{1,2,3}'].
	self assert: [ (object attributeValueFor: 'scalar') isNil ].
! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 2/26/2011 20:36'!
testHasEmbeddedChildren
	"self deny: [ object hasEmbeddedChildren ].
	self addEmbeddedObjects.
	self assert: [ object hasEmbeddedChildren]."! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:57'!
testMappedDescription
	self assert: [ object mappedDescription children size = 5 ].
! !
